Description

foreman_salt fails its unit test. The code it uses doesn't override related parts.

/home/runner/work/foreman_salt/foreman_salt/app/controllers/concerns/find_common.rb:50: warning: U

sing the last argument as keyword parameters is deprecated; maybe ** should be added to the call

/home/runner/work/foreman_salt/foreman_salt/app/models/host.rb:2: warning: The called method `meth

od_missing' is defined here

[MinitestRetry] retry 'test_0006_salt variable matching host with hostgroup specific value' count:

 1,  msg: NoMethodError: undefined method `empty?' for #<ActiveRecord::QueryMethods::WhereChain:0x

00005e8b1602df28>

    app/controllers/concerns/find_common.rb:12:in `resource_finder'

    app/controllers/concerns/find_common.rb:8:in `find_resource'

    app/controllers/concerns/foreman/controller/timezone.rb:10:in `set_timezone'

    app/models/concerns/foreman/thread_session.rb:32:in `clear_thread'

    app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12:in `set_topbar_sweeper_contro

ller'

    foreman_salt/test/functional/minions_controller_test.rb:99:in `block in <class:MinionsControll

erTest>'

 There appears to be a difference in calling resource.where([]) and resource.where(*[]).

Associated revisions

Revision 6c77d09b - 03/19/2024 01:42 PM - Ewoud Kohl van Wijngaarden

Fixes #37273 - Use delegation syntax for resource_scope

In Ruby 3 you need to explicitly delegate keyword arguments, or if you

don't care about Ruby 2.6 or prior then you can use the new delegation

syntax

1

.

It deals with the difference in calling where. When calling `.where([])`

it returns an array while `.where(*[])` returns an instance of

`WhereChain` which consumers of the method can't deal with. Because of

that it calls `.all`.

[1]: https://www.ruby-lang.org/en/news/2019/12/12/separation-of-positional-and-keyword-arguments-in-ruby-3-0/

History

#1 - 03/15/2024 04:47 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/foreman/pull/10097 added
#2 - 03/19/2024 01:42 PM - The Foreman Bot

- Fixed in Releases 3.11.0 added

#3 - 03/19/2024 02:00 PM - Ewoud Kohl van Wijngaarden

- Status changed from Ready For Testing to Closed

Applied in changeset foreman|6c77d09b44456bc1770f0264f41c1238557c64fa.

#4 - 03/19/2024 02:18 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/10103 added

#5 - 03/20/2024 06:03 PM - The Foreman Bot

- Fixed in Releases 3.10.0 added
